#include "delay.h"
#include "stdio.h"

extern void uart2_rxtx_init(void);

float get_voltage()
{
	while(!((ADC1->SR)&ADC_SR_EOC)){;}
	uint16_t adc_value= ADC1->DR;

	return (float)((adc_value)*3300/4095)/1000;

}


float pressure (float voltage)
{
return (float)(voltage - 0.33)/(2.475);

}



int main(void)
{
	uart2_rxtx_init();
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN; //enable gpio a clock
	RCC->APB2ENR|=RCC_APB2ENR_ADC1EN; //enable adc clock
	GPIOA->MODER|=GPIO_MODER_MODER1;  //set the PA1 to analog mode
	ADC1->CR2=0; //disable the adc
	ADC1->CR2|=ADC_CR2_CONT;
	ADC1->SQR3|=1; //we are converting only one channel
	ADC1->CR2|=1; //enable the adc
	ADC1->CR2|=ADC_CR2_SWSTART; //start adc conversion

	while(1)
		{
			printf("pressure is = %f MPa\r\n",pressure(get_voltage()));
			delay(500);
		}

}
